package imageMedd.app;

import java.awt.Button;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.BufferedImage;

public class ImageDisplayApp extends Frame {
	private static final long serialVersionUID = 1L;
	//private final this this = new this("Image");
	private final BufferedImage image;
	public ImageDisplayApp(BufferedImage im) {
		super();
		image = im;
		this.setSize(image.getWidth(),image.getHeight());
		this.setLayout(new FlowLayout(FlowLayout.CENTER));
		this.setBackground(new Color(0xFFDDDDDD));
		this.setVisible(true);
		this.getGraphics().drawImage(image, 0, 0, null);
		this.getGraphics().draw3DRect(2, 2, 2, 2, true);
		Button b = new Button("Close");
		b.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				dispose();
			}
		});
        this.addWindowListener(new WindowAdapter() {
            @Override
        	public void windowClosing(WindowEvent e) {dispose();}
        });
		this.add(b);
	}
	
	@Override
	public void paint(Graphics g) {
		this.getGraphics().drawImage(image, 0, 0, null);
	}
	
	public void kill() {
		this.dispose();
	}	
}
