package imageMedd.app;

import imageMedd.ImageManager;

import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;


public class LoadImageButtonActionListener implements ActionListener {
	private TextField t;
	private int ind;
	private Apple app;

	public LoadImageButtonActionListener(TextField t, int ind, Apple app) {
		this.t = t;
		this.ind = ind;
		this.app = app;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		try {
			File file;
			try {
				file = new File(t.getText());
			} catch(Exception ex) {
				file = new File(".");
			}
			JFileChooser chooser = new JFileChooser();
			chooser.setCurrentDirectory(file);
			chooser.setDialogTitle("Select");
			chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
			chooser.setMultiSelectionEnabled(true);

			FileFilter filter = new FileNameExtensionFilter("File Extensions",
					"png", "jpeg", "bmp", "jpg");
			chooser.setFileFilter(filter);

			/* Disable the "All files" option */
			chooser.setAcceptAllFileFilterUsed(false);
			File files[] = new File[3];
			if (chooser.showOpenDialog(new TextField()) == JFileChooser.APPROVE_OPTION) {
				files = chooser.getSelectedFiles();
			}
			if (files.length != 1)
				return;
			// Read the image specified in text field
			// BufferedImage image = ImageIO.read(new File(t.getText()));
			BufferedImage image = ImageIO.read(files[0]);
			// Enter it to image manager
			ImageManager.getInstance().setImage(ind, image);
			// Image manager creates a new window with the picture
			ImageManager.getInstance().produceView(ind);
			// Control says success
			app.controlSays("Image " + ind + " loaded!", Apple.successColor);
		} catch (IOException ex) {
			// Control says failure
			app.controlSays("Image " + ind + " cannot load", Apple.failColor);
		}
	}
}
