package imageMedd.app;

import imageMedd.transformers.Transformer;

import java.awt.Button;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JLabel;


public class PublicHelp extends Frame {
	private static final long serialVersionUID = 1L;
	private static final int bgColor = 0xFFFFDD;
	// Help text
	private static String helpText = "<html><u><i>General Help:</i></u><br>" +
			"To load an image, press load button in one of the slots available.<br>" +
			"You may input the image folder in the text field.<br>" +
			"Press the available buttons to destroy your image as you like.<br>" +
			"Entering a parameter may give different results on some buttons!<br>" +
			"You may enter only integers, but you can enter them under hexdecimal base, by adding '0x' before them.<br>" +
			"When done, you may:<br>" +
			"1. Specify file path (or just name) to flush it to a file or <br>" +
			"2. Print \"#[number]\" to flush it to one of the available slots.<br>" +
			"Control label at the bottom is <font color = \""
			+ Apple.successColor
			+ "\">green</font> on success, <font color = \""
			+ Apple.failColor
			+ "\">red</font> on failure.<br><u>Buttons descriptions:</u><br>";
	// Help Jlabel
	JLabel help;
	// Window size
	private int width = 950, height = 580;

	public PublicHelp() {
		super();
		this.setLayout(new FlowLayout(FlowLayout.CENTER));
		this.setBackground(new Color(bgColor));
		this.setSize(width, height);
		for (Transformer t : Transformer.transformers.values()) {
			helpText += "<u>" + t.getString() + "</u> - " + t.help() + "<br>";
		}
		helpText += "<br>HAVE FUN!!</html>";
		help = new JLabel(helpText, JLabel.LEFT);
		this.add(help);
		Button b = new Button("Close");
		b.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				dispose();
			}
		});
		this.addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				dispose();
			}
		});
		this.add(b);
		this.setVisible(true);
	}

	public void kill() {
		this.dispose();
	}
}
