package imageMedd.app;

import imageMedd.ImageManager;
import imageMedd.transformers.Transformer;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


public class TransformButtonActionListener implements ActionListener {
	private final Transformer t;
	private final ImageManager im;
	private final Apple app;
	private static final PrivateHelp privateHelp = new PrivateHelp();

	public TransformButtonActionListener(Transformer t, ImageManager im,
			Apple app) {
		this.t = t;
		this.im = im;
		this.app = app;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		try {
			t.setParam(app.getParam());
			long time = System.currentTimeMillis();
			t.accept(im);
			time = System.currentTimeMillis() - time;
			app.controlSays("Operation complete. Time elapsed: " + time +"msec",
					Apple.successColor);
			im.produceResultView();
		} catch (RuntimeException ex) {
			privateHelp.changeTransformer(t);
			privateHelp.setVisible(true);
			app.controlSays(ex.getMessage(), Apple.failColor);
		}
	}
}
