package imageMedd.transformers;


/**
 * @author OpenG 
 * 		   A SpecTransformer is a transformer, which in addition to being
 *         a transformer, has the setParam function implemented as empty
 *         (getting parameters may be possible by Overriding it), and by
 *         default, adds itself on construction to the transformers map for
 *         quick finding in the ImageManager.
 *         refer to Warper and PixelCompositor.
 */
public abstract class SpecTransformer implements Transformer {
	public SpecTransformer() {
		Transformer.transformers.put(this.getString(), this);
	}

	@Override
	public void setParam(int[] param) {

	}
	
	@Override
	public String help() {
		return "A generic transformer.";
	}
	
	@Override
	public String generalHelp() {
		return "";
	}
}
