package imageMedd.transformers;


import imageMedd.transformers.compositors.PixelCompositor;
import imageMedd.transformers.warpers.Warper;

import java.util.Map;


public class TransformerPrinter implements TransformerVisitor {
	protected final Map<String, Transformer> map;
	
	public TransformerPrinter() {
		this.map = Transformer.transformers;
	}
	
	public void printHelp() {
		System.out.println("Available commands:");
		for (Map.Entry<String, Transformer> e : map.entrySet()) {
			System.out.print("\t"+e.getKey());
			e.getValue().accept(this);
		}		
	}
	
	@Override
	public void visit(Warper w) {
		System.out.println("\tImage warper.\t\tCommand: [mode] [src] [dst]");	
	}

	@Override
	public void visit(PixelCompositor c) {
		System.out.println("\t\tImage compositor.\tCommand: [mode] [src1] [src2] [dst]");
	}

}
