package imageMedd.transformers.compositors;

import imageMedd.Pixel;
import imageMedd.transformers.TransformerVisitor;

public class Atopper extends PixelCompositor {
	static final String key = "-atop";
	
	public Atopper() {
		super();
	}

	@Override
	public Pixel composite(Pixel p, Pixel q) {
		return Pixel.atop(p, q);
	}

	@Override
	public void accept(TransformerVisitor v) {
		v.visit(this);
	}

	@Override
	public String getString() {
		return key;
	}	
	
	@Override
	public String help() {
		return "Performs \"image1 atop image2\"";
	}
}
