package imageMedd.transformers.compositors;

import imageMedd.Pixel;
import imageMedd.transformers.TransformerVisitor;

public class Masker extends PixelCompositor {
	static final String key = "-mask";

	public Masker() {
		super();
	}
	
	@Override
	public Pixel composite(Pixel p, Pixel q) {
		int a = q.getR()+q.getG()+q.getB();
		Pixel res = new Pixel(p);
		res.setA(a/3);
		return res;
	}

	@Override
	public void accept(TransformerVisitor v) {
		v.visit(this);
	}

	@Override
	public String getString() {
		return key;
	}
	
	@Override
	public String help() {
		return "Applies image 2's color level as level of transparency for image 1";
	}
}
