package imageMedd.transformers.compositors;

import imageMedd.Pixel;
import imageMedd.transformers.SpecTransformer;

/**
 * @author OpenG 
 * 		   PixelCompositor are transformers capable of performing
 *         compositing actions on two single pixels, regardless of their
 *         locations or neighbors.
 *         Since they're so independent, it's easy to parallelize their 
 *         actions on the whole image, but that is handled by ImageManager.
 */
public abstract class PixelCompositor extends SpecTransformer {
	PixelCompositor() {
		super();
	}

	public abstract Pixel composite(Pixel p, Pixel q);
	
	@Override
	public String generalHelp() {
		return "This is a Pixel Compositor: recieves two images and creates a composition. A certain point in the result is dependent only on that same point in the source images.";
	}
}
