package imageMedd.transformers.compositors;

import imageMedd.Pixel;
import imageMedd.transformers.TransformerVisitor;

public class ReplaceWith extends PixelCompositor {
	private static String key = "-repw";
	private static int color1 = 0xFFFFFFFF, rad = 0;
	private static boolean regardAlpha = false;

	public ReplaceWith() {
		super();
	}

	@Override
	public Pixel composite(Pixel p, Pixel q) {
		if ((regardAlpha && Pixel.distance(p, new Pixel(color1)) <= rad)
				|| (!regardAlpha && Pixel.colorDistance(p, new Pixel(color1)) <= rad))
			return q;
		else
			return p;
	}

	@Override
	public void accept(TransformerVisitor v) {
		v.visit(this);
	}

	@Override
	public String getString() {
		return key;
	}

	@Override
	public void setParam(int[] param) {
		switch (param.length) {
		case 0:
			throw new RuntimeException("Colors unknown.");
		case 1:
			color1 = param[0];
			rad = 0;
			break;
		default:
			regardAlpha = (param[2] == 0);
		case 2:
			if (param[1] < 0)
				throw new RuntimeException("No negative radiuses.");
			color1 = param[0];
			rad = param[1];
			break;
		}
	}
	
	@Override
	public String help() {
		return "Replaces every color in image 0, which is close enough to color 1, to the pixel in that position in image 1. Receives the color to replace in parameter 0,<br> and the distance at parameter 1. Put 0 in parameter 3 to calculate distance with alpha channel.";
	}
}
