package imageMedd.transformers.compositors;

import imageMedd.Pixel;
import imageMedd.transformers.TransformerVisitor;

public class Xorer extends PixelCompositor {
	static final String key = "-xor";

	public Xorer() {
		super();
	}
	
	@Override
	public Pixel composite(Pixel p, Pixel q) {
		return Pixel.xor(p, q);
	}
	
	@Override
	public void accept(TransformerVisitor v) {
		v.visit(this);
	}
	
	@Override
	public String getString() {
		return key;
	}
	
	@Override
	public String help() {
		return "Performs \"image1 xor image2\".";
	}
}
