package imageMedd.transformers.warpers;

import imageMedd.Pixel;

import java.awt.image.BufferedImage;


public class OrderedDither extends FloydSteinbergDither {
	// private final int nbits;
	private static final String key = "-ordered";
	private static final int bayer4[][] = { { 0, 60, 24, 84 },
			{ 48, 12, 72, 36 }, { 60, 48, 0, 12 }, { 84, 72, 24, 36 } };

	public OrderedDither(int bits) {
		super(bits);
	}

	@Override
	public BufferedImage warp(BufferedImage image1) {
		BufferedImage result = new BufferedImage(image1.getWidth(), image1
				.getHeight(), BufferedImage.TYPE_INT_ARGB);
		for (int i = 0; i < image1.getWidth(); i++)
			for (int j = 0; j < image1.getHeight(); j++) 
				result.setRGB(i, j, image1.getRGB(i, j));
		for (int i = 0; i < result.getWidth(); i++)
			for (int j = 0; j < result.getHeight(); j++) {
				Pixel p = this.quantize(Pixel.add(
						new Pixel(image1.getRGB(i, j)),
						new Pixel(bayer4[i % 4][j % 4], bayer4[i % 4][j % 4],
								bayer4[i % 4][j % 4], 255)));
				result.setRGB(i, j, p.getRGB());
			}
		return result;
	}

	@Override
	public String getString() {
		return key;
	}
	
	@Override
	public String help() {
		return "Performs ordered dither on the image. Takes number of color bits on parameter 0.";
	}
}
