package imageMedd.transformers.warpers;

import imageMedd.transformers.TransformerVisitor;

import java.awt.image.BufferedImage;


public class Sinner extends Warper{
	private final String key = "-sin";
	private int waveNum = 1, amplitude = 1;
	public Sinner() {
		super();
	}

	@Override
	public BufferedImage warp(BufferedImage image1) {
		BufferedImage result = new BufferedImage(image1.getWidth(), image1
				.getHeight(), BufferedImage.TYPE_INT_ARGB);
		if (image1.getWidth() < amplitude)
			amplitude = image1.getWidth();
		for (int j = 0; j<image1.getHeight();j++) {
			int k = 0;
			for (int i = (int)(image1.getWidth()+amplitude*Math.sin(waveNum*j*6.28/180)) % (image1.getWidth());i<image1.getWidth();i++) {
				result.setRGB(i, j, image1.getRGB(k, j));
				k++;
			}
			for (int i = 0; i<(int)(image1.getWidth()+amplitude*Math.sin(waveNum*j*6.28/180)) % (image1.getWidth());i++) {
				result.setRGB(i, j, image1.getRGB(k, j));
				k++;
			}
		}
		return result;
	}
	
	@Override
	public void accept(TransformerVisitor v) {
		v.visit(this);
	}
	
	@Override
	public void setParam(int[] param) {
		if (param.length > 0)
			this.waveNum = param[0];
		if (param.length > 1)
			this.amplitude = param[1];
	}

	@Override
	public String getString() {
		return key;
	}
	
	@Override
	public String help() {
		return "Twists the picture with a sine wave. Gets sine intensity at parameter 0, and size at parameter 1.";
	}
}
