package imageMedd.transformers.warpers;

import imageMedd.transformers.SpecTransformer;

import java.awt.image.BufferedImage;


/**
 * @author OpenG
 *		Warpers are transformers meant to receive a whole image and 
 *		transform its pixels, mostly depending on the whole image's data.
 *		Since those dependencies vary with each action possible, no 
 *		trivial parallelization is available.
 */
public abstract class Warper extends SpecTransformer {
	Warper() {
		super();
	}
	public abstract BufferedImage warp(BufferedImage image1);
	
	@Override
	public String generalHelp() {
		return "This is a Warper: recieves one image (slot #0) and creates a new image out of it.";
	}
}
